/*
 * unit_test.c - run unit tests
 */


#include <stdio.h>
#include <stdlib.h>


#include "lodju.h"


int main(int argc, char **argv)
{
    static struct {
	const gchar *name;
	gint (*run)(void);
    } tests[] = {
	{ "image", image_unit_test },
	{ "pixbuf", pixbuf_unit_test },
	{ "utils", utils_unit_test },
    };
    static const gint num_tests = sizeof(tests) / sizeof(tests[0]);
    gint i;
    
    printf("Running unit tests...\n");
    
    gettext_init();
    gtk_init(&argc, &argv);
    glade_init();
    
    for (i = 0; i < num_tests; ++i) {
	printf("Module %s:\n", tests[i].name);
	if (tests[i].run() == -1) {
	    printf("UNIT TESTING FAILED!\n");
	    return EXIT_FAILURE;
	}
    }
    printf("All tests completed OK.\n");

    return 0;
}
